allocate 0 888:1
open data m-ibmspln.dat
data(org=obs) / r1 r2

* stats / r1
* set h1 = %var

set h1 = 0.0
set h2 = 0.0

nonlin a0 a1 b1 a00 a11 b11 rho c1 c2 p1 p2 b2 b22
frml a1t = r1(t)-c1-p1*r1(t-1)
frml a2t = r2(t)-c2-p2*r2(t-1)

frml gvar1 = a0  + a1*(a1t(t-1)**2) + b1*h1(t-1) + b2*h2(t-1)
frml gvar2 = a00 + a11*(a2t(t-1)**2)+ b11*h2(t-1) + b22*h1(t-1)

frml gdet = -0.5*(log(h1(t)=gvar1(t))+log(h2(t)=gvar2(t)) $
   +log(1.0-rho**2))
frml gln = gdet(t)-0.5/(1.0-rho**2)*((a1t(t)**2/h1(t)) $
   +(a2t(t)**2/h2(t))-2*rho*a1t(t)*a2t(t)/sqrt(h1(t)*h2(t)))

smpl 3 888
compute c1=1.22, c2=0.57, p1=0.1, p2=0.1, rho=0.1
compute a0=3.27, a1=0.1, b1=0.6, b2 =.0
compute a00=1.17, a11=0.13, b11=0.8, b22 = .0

maximize(method=bhhh,recursive,iterations=150) gln

* First equation

set fv1 = gvar1(t)
set resi1 = a1t(t)/sqrt(fv1(t))
set residsq = resi1(t)*resi1(t)
* Checking standardized residuals *
cor(qstats,number=16,span=4) resi1
* Checking standardized residuals *
cor(qstats,number=16,span=4) residsq

* Second equation

set fv2 = gvar2(t)
set resi2 = a2t(t)/sqrt(fv2(t))
set residsq = resi2(t)*resi2(t)
* Checking standardized residuals *
cor(qstats,number=16,span=4) resi2
* Checking standardized residuals *
cor(qstats,number=16,span=4) residsq

* Last few obervations needed for computing forecasts *

set shock1 = a1t(t)
set shock2 = a2t(t)
print 885 888 shock1 shock2 fv1 fv2

graph 1
# resi1 1 888
graph 1
# resi2 1 888



